# tailwind-3dtransform-plugin

[![CodeQL](https://github.com/XPD-Kasun/tailwind-3dtransform-plugin/actions/workflows/github-code-scanning/codeql/badge.svg)](https://github.com/XPD-Kasun/tailwind-3dtransform-plugin/actions/workflows/github-code-scanning/codeql) [![Run Tests](https://github.com/XPD-Kasun/tailwind-3dtransform-plugin/actions/workflows/jest.yaml/badge.svg)](https://github.com/XPD-Kasun/tailwind-3dtransform-plugin/actions/workflows/jest.yaml) [![Build Documentation Website](https://github.com/XPD-Kasun/tailwind-3dtransform-plugin/actions/workflows/build-docs.yml/badge.svg)](https://github.com/XPD-Kasun/tailwind-3dtransform-plugin/actions/workflows/build-docs.yml)

This plugin generates necessary classes for perspective, rotation, translate, scale and many other transforms.

We currently supports,

- translateX, translateY, translateZ, translate3d
- rotateX, rotateY, rotateZ, rotate3d
- scaleX, scaleY, scaleZ, scale3d
- perspective
- backface-visibility
- perspective-origin
- transform-style
- transform-box
- flip

To quickly get started, [learn how to use tailwind-3d-transforms in your project](https://xpd-kasun.github.io/tailwind-3dtransform-plugin/).

## Documentation

You can find the documentation [on the website](https://xpd-kasun.github.io/tailwind-3dtransform-plugin/).

Check out [quick-start guide](https://xpd-kasun.github.io/tailwind-3dtransform-plugin/) to quickly install and configure your tailwindcss environment to use tailwind 3d transform plugin.

The documentation has following sections.

- [Quick Start](https://xpd-kasun.github.io/tailwind-3dtransform-plugin/)
- [Guide](https://xpd-kasun.github.io/tailwind-3dtransform-plugin/category/guide)
- [FAQ (Frequently Asked Questions)](https://xpd-kasun.github.io/tailwind-3dtransform-plugin/category/faq)

You can also improve the documentation by creating pull requests by clicking on "Edit this page" link on every documentation page. You are welcome to do this if you find useful improvements or points I may have missed.

## Contributing

Our goal is to make 3d transforms available for tailwindcss. I completed the v1.0.3 of this plugin myself. I hope the community find this useful and maintain and further develop this repository.

If you have an issue, you can open an issue [here](https://github.com/XPD-Kasun/tailwind-3dtransform-plugin/issues). To create a new issue, click on New Issue button.

To contribute by extending this library, please first fork the library, and then implement your proposed changes. Finally, when you're done, create a PR(Pull Request) in this repository. Please note that in order to merge, we need to pass the automated tests including documentation. We do at pull-request time also.

Thank You Very Much 😊.

## License

Tailwind-3dTransform-Plugin is [MIT Licensed](https://github.com/XPD-Kasun/tailwind-3dtransform-plugin/blob/main/LICENSE).


