import { type CSSUtility } from '@/css-utilities';
import { Base } from '@/css-utilities/base';
import { type UnsafeCSSValue } from '@/utils/css-value';
import { type Dimension } from '@/utils/dimension';
interface NormaliseFunctionValuesOptions {
    dimension?: Dimension;
    scaleX?: UnsafeCSSValue;
    scaleY?: UnsafeCSSValue;
    scaleZ?: UnsafeCSSValue;
}
interface ScaleDeclarations {
    scale: string;
}
export declare class Scale extends Base implements CSSUtility {
    private isProcessableValue;
    private isProcessableValues;
    private normaliseValues;
    static defaultFunctionValues: Required<Omit<NormaliseFunctionValuesOptions, 'dimension'>>;
    static normaliseFunctionValues: ({ dimension, scaleX, scaleY, scaleZ, }?: NormaliseFunctionValuesOptions) => string;
    static declarations: (values?: NormaliseFunctionValuesOptions) => ScaleDeclarations;
    static legacyDeclarations: () => import("@/css-utilities").TransformDeclarations;
    utilities: () => void;
}
export {};
